<?php

namespace App\Http\Controllers;
use DB;
use Auth;
use File;
use DateTime;
use Repsonse;
use Exception;
use GeoIP as GeoIP;
use App\Models\Plan;
use App\Models\User;
use App\Models\Share;
use App\Models\DoList;
use App\Models\Feature;
use App\Mail\ShareEmail;
use App\Models\Follower;

// use Barryvdh\DomPDF\PDF;
use App\Models\Question;
use App\Models\Get_Result;
use App\Models\PollingList;
use App\Models\QuestionType;
use Illuminate\Http\Request;
use App\Models\PollingBefore;
// use Barryvdh\DomPDF\Facade as PDF;
use App\Models\PollingQuestion;
use Barryvdh\DomPDF\Facade\Pdf;
use App\Models\QuestionResponse;
use App\Mail\PollAssignTaskEmail;
use App\Models\Polling_Assign_Task;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Support\Facades\Validator;
use SimpleSoftwareIO\QrCode\Facades\QrCode;



class PollController extends Controller
{
    private $editCounter = 1;

    // old
    public function poll()
    {
        $login_user = auth()->user();

        $package = Plan::where('code', $login_user->package_name)->first();

        $features_ids = json_decode($package->sub_feature);
        $polling_1 = Feature::whereIn('id', $features_ids)->where('short_code', 'polling_funel')->first();

        // $pollinglists = PollingList::where('client_id',$login_user->id)->get();
        $pollinglists = PollingList::where('client_id',$login_user->id)->paginate(1);
        $question_count = Question::where('client_id',$login_user->id)->count();

        // dd($pollinglists[0]);

        return view('poll.poll',compact('polling_1','login_user','pollinglists','question_count'));
    }
    // old

    public function poll_result()
    {
        $login_user = auth()->user();

        // $user=Auth::id();
        $package = Plan::where('code',$login_user->package_name)->first();

        $features = json_decode($package->sub_feature);
        $polling_2 ="";
        foreach($features as $feature)
        {
            $featureData =  Feature::where('id',$feature)->first();
            if($featureData->short_code=="polling_funel")
            {
                $polling_2 = $featureData;
            }
        }

        $pollinglists=PollingList::where('client_id', $login_user->id)->get();
        return view('poll.poll_result',compact('pollinglists','polling_2'));

    }

    // old
    public function createpoll()
    {
        $login_user = auth()->user();
        $role = getRole();
        if($role->hasPermissionTo('polling list generate poll'))
        {
            return view('poll.create_poll_question', compact('login_user'));
        }
        else
        {
            return back();
        }
    }
    // old

   //Add Qeustion
    public function questionnare(Request $request)
    {
        $counter= $request->counter ?? 0;

        $type = QuestionType::get();

        $questionType = $request->type;

        return response()->json(['html' => view('poll.question' , ['counter' => $counter ,'types' => $type , 'questionType' => $questionType])->render(),  'counter'=>$counter++ , 'status'=>'success', 'msg'=>'Successfully']);
    }

    public function poll_append_question(Request $request)
    {
        $type = $request->type;

        $parentQuestion = $request->parentQuestion;

        $margin = $request->margin;

        $questionType = QuestionType::get();

        return response()->json(['html' => view('poll.components.polling-append-question' , ['type' => $type , 'parentQuestion' => $parentQuestion ,'questionType' => $questionType , 'margin' => $margin])->render() ,  'status'=>'success', 'msg'=>'Successfully']);
    }

    public function update_polling(Request $request)
    {
        // dd($request->all());
        try{
       $pollingId = $request->id;
       $rankingIndex = 0;
       $rankingQuestion =  Question::where('polling_id' , $request->id)->where('input' , 'ranking')->get()->pluck('response_id');
       $questionList = $request->questionList;
        // dd($request->all());
       QuestionResponse::whereIn('id', $rankingQuestion)->delete();
       Question::where('polling_id' , $request->id)->delete();
        $rankings = $request->createdRanking ?? [];
        $rankingIds = [];
        $ranking = 0;
        $userId = auth()->user()->id;

        foreach($rankings as $ranking)
        {
           $response =  json_encode($ranking);
           $rankingIds[] =  QuestionResponse::insertGetId(['client_id' => $userId , 'response' => $response, 'hidden_response' => 1 ]);

        }

        $questionIds = [];
        // dd($questionList);
        foreach($questionList as $key => $question)
        {
            $questionText = $question[0];
            $inputType = $question[1];
            $parentIndex = $question[3];
            $questionType = $question[4];
            $logicTrigger = $question[5];
            $logicResponse = $question[6];
            //getting response id
            if($inputType == 'ranking') {
                $responseId = $rankingIds[$rankingIndex];
                $rankingIndex++;
            }else{
                $responseId = $question[2];
            }
            //getting parent id

            $parentId = isset($parentIndex) && !is_null($parentIndex) ?  $questionIds[(int)$parentIndex] : $parentIndex;


            $questionIds[] = Question::insertGetId([
                "type_id" => $questionType,
                "question" => $questionText,
                "polling_id" => $pollingId,
                "logic_trigger" => $logicTrigger,
                "response" => $logicResponse,
                "parent_question" => $parentId,
                "client_id" => auth()->user()->id,
                "input" => $inputType,
                'response_id' => $responseId
            ]);
        }


        // dd($questionIds);

        return response()->json(['success'=> true , 'msg' => 'Successfully updated polling']);
        }
        catch(Exception $e)
        {
            return response()->json(['success'=> false , 'msg' => 'Something went wrong' ,'error-line' => $e->getLine() , 'error' => $e->getMessage()]);
        }
    }



    //add polling question
    public function addquestion(Request $request)
    {
        // dd($request->all());

        $rankingResponse = $request->createdResponse;

        $rankingIds = [];
        if(isset($rankingResponse) && is_array($rankingResponse))
        {
            foreach($rankingResponse as  $rankingArray)
            {
                $rankingString = json_encode( $rankingArray );
                $clientId = auth()->user()->id;
                $hiddenResponse = 1;
                $id = QuestionResponse::insertGetId(['response' => $rankingString , 'client_id' => $clientId , 'hidden_response' => $hiddenResponse]); //question_responses table
                $rankingIds[] = $id;
            }
        }
        $login_user = auth()->user();
        $questions=$request->question;
        $isAdded = false;
        $polling=PollingList::create([  //polling_list table
            'client_id'=>$login_user->id,
            'polling_name'=>$request->polling_name,
            'poll_closing_date'=>$request->poll_closing_date,
            'poll_closing_time'=>$request->poll_closing_time,
            'status' => 0
        ]);

        $characters = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $char = substr(str_shuffle($characters), 0, 8);

        $domain=ENV('APP_URL');
        $link=$domain.'/'.'poll/questions';
        $code=$link.'/'.$char.''.$polling->id;
        $token=$char.''.$polling->id;
        // dd($code);

        QrCode::size(180)->generate($code, 'images/questioncodes/poll-'.$polling->id.'.svg');  //generate qr_code
        $img_url = ('poll-'.$polling->id.'.svg');

        PollingList::where('id',$polling->id)->update([ //polling_list table
            "token" => $token,
            "qrcode" => $img_url
        ]);

        $dataArr = array();
        $d = 0;
        $child = 0;
        foreach($questions as $key=>$value)
        {
            if($request["parent_question".$request->counter[$key]] == '')
            {
                $dataArr["parents"][] = $request->counter[$key];
                $dataArr["child"][$d]["question"] = $request->counter[$key];
                $dataArr["child"][$d++]["parent_question"] = '';
            }
            else
            {
                $dataArr["child"][$d]["question"] = $request->counter[$key];
                $dataArr["child"][$d++]["parent_question"] = $request["parent_question".$request->counter[$key]];
            }
        }

        $role=User::where('id',$login_user->id)->pluck('role')->first();
        // dd($role);
        $rankingCount = 0;
        foreach ($dataArr["child"] as $key => $parent)
        {
            $parent = $parent["question"];
            $question=new Question(); //pollling_questions table
            $question->question=$request->question[$parent];
            $question->response_id=$request->response_id[$parent];

            $question->input = $request->input[$key];

            if($question->input == "ranking")
            {
                $question->response_id = $rankingIds[$rankingCount];
                $rankingCount++;
            }else{
                $question->response_id=$request->response_id[$parent];
            }


            $question->role=$role;
            $question->parent_question = 0;

            $question->response = isset($request["response".$request->counter[$parent]]) ? $request["response".$request->counter[$parent]] : '';
            $question->is_required = isset($request["is_required".$request->counter[$parent]]) ? 1 : 0;
            $question->logic_trigger = isset($request["trigger".$request->counter[$parent]]) ? 1 : 0;
            $question->is_multiple = isset($request["is_multiple".$request->counter[$parent]]) ? 1 : 0;
            $question->is_action_required=$request->is_action_required;
            $question->parent_question = 0;
            $question->schedule_Date=$request->schedule_Date;
            $question->polling_id=$polling->id;
            $question->client_id=$login_user->id;
            $question->created_by=$request->created_by;
            $question->type_id = $request->questionType[$key];
            $question->save();
            $lastId = $question->id;
            $dataArr["child"][$key]["db_id"] = $lastId;

        }

        foreach ($dataArr["child"] as $key => $parent)
        {
            $db_id = $parent["db_id"];
            $parent_question = $parent["parent_question"];
            $parent_id = null;
            if($parent["parent_question"] != '')
            {
                foreach ($dataArr["child"] as $k => $child)
                {
                    if($child["question"] == $parent_question)
                    {
                        $parent_id = $child["db_id"];
                    }
                }
            }
            $dataArr["child"][$key]["parent_id"] = $parent_id;
            $question=Question::find($db_id); //pollling_questions table
            $question->parent_question = $parent_id;
            $question->save();
            $isAdded = true;
        }

        if($isAdded)
        {
            return response()->json(['status'=>'success','msg'=>'Question Added Successfully','data'=>$dataArr]);
        }
        else
        {
            return response()->json(['status'=>'fail','msg'=>'Something Went Wrong ','data'=>$dataArr]);
        }
    }

    //Update Question
    public function editquestion($id)
    {
        $login_user = auth()->user();
        $role = getRole();
        if($role->hasPermissionTo('polling list edit'))
        {
            $poll_name=Question::where('polling_id',$id)->first();
            $question_id=Question::where('polling_id',$id)->count();
            $pollingQuestions = Question::with('questionResponse','children')->where('polling_id' , $id)->whereNull('parent_question')->get();
            $responses = QuestionResponse::where(function($query){
                $query->where('client_id', auth()->user()->id)->where('hidden_response', 0);
            })->get();

            $poll_list = PollingList::where('id',$id)->with('pollingListWithResponce')->first(); //pollling_questions table
            $questionTypes = QuestionType::all();

            if($poll_list)
            {
                return view('poll.Edit_poll_question',compact('poll_list','poll_name','question_id','pollingQuestions', 'responses', 'id', 'questionTypes', 'login_user'));
            }
            else
            {
                return view('404');
            }
        }
        else
        {
            return back();
        }
    }

    public function get_hidden_response(Request $request)
    {
        // dd($request->responseTitle);
        $response=QuestionResponse::where( ['response_title' => $request->responseTitle , 'hidden_response' => 1])->first(); //question_responses table
        $options = '';
        $option = '';
        if(isset($response)){
            foreach(json_decode($response->response) as $value)
            {
                $option .= '<span class="badge rounded-pill bg-success">'.ucwords($value).'</span>&nbsp;&nbsp;';
                $options .= '<option value="'.($value).'"> '.($value).' </option>';

            }
        }
        $options .= '';

        return response()->json(['status'=>'success','msg'=>'Successfully','html'=>$options,'htmltwo'=>$option]);
    }



    public function getPollingQuestions($id){

        $parentQuestions = Question::where('polling_id',$id)->where('parent_question','')->get();
        $counter = 1;
        $response = array();
        $html = "";

        foreach ($parentQuestions as $key => $parent) {
            $html .= self::getQuestion($parent["polling_id"],$parent["id"],$this->editCounter++);
        }

        return response()->json(['status'=>'success','msg'=>'Successfully','parents' => $parentQuestions,'html'=>$html,'counter'=>$this->editCounter]);
    }

    public function getQuestion($polling_id,$question_id,$counter)
    {

        $child = Question::where('polling_id',$polling_id)->where('parent_question',$question_id)->first();

        $trigger_response = Question::where('id',$question_id)->first();
        $is_required = $trigger_response->is_required == 1 ? 'checked' : '';
        $is_multiple = $trigger_response->is_multiple == 1 ? 'checked' : '';
        $response_id = $trigger_response->response_id;

        // $trigger_ask_question=Question::where('id',$question_id)->pluck('logic_trigger')->first() == 1 ? 'selected' : '';
        // $trigger=Question::where('id',$question_id)->pluck('logic_trigger')->first() == 0 ? 'selected' : '';
        $response_name=QuestionResponse::where('id',$response_id)->pluck('response')->first();

        $arr_responses=json_decode($response_name);
        $response_html = "";
        $response_options = "";
        $input= "";
        if($question_id)
        {
            $display='d-none';
        }

        if($response_id!=NULL)
        {
            foreach($arr_responses as $response)
            {
                $response_html .= '<span class="badge rounded-pill bg-success">'.ucwords($response).'</span>&nbsp;&nbsp;';
                $response_options .= '<option value="'.$response.'" '.($trigger_response->response==$response ? 'selected' : ''). '>'.ucwords($response).'</option>';
            }
        }
        else
        {
            $input= 'input';
            $response_html .= '<span class="badge rounded-pill bg-success">'.ucwords('input').'</span>&nbsp;&nbsp;';
        }

        $html ='<div class="col-lg-12">
                <input type="hidden" name="parent_question'.$counter.'" id="parent_question'.$counter.'" value="">
                <input type="hidden" name="question_id'.$counter.'" id="question_id'.$counter.'" value="'.$question_id.'">
                <div class="card shadow-none" id="ParentQuestion'.$counter.'">
                    <div class="card-header border border-dark" style="background-color:#f7f7f7;">
                        <div class="row p-0 m-0">

                            <div class="col-lg-8  border-dark border-end pt-1">
                                <labbel class="font-weight-bold">Question '.$counter.'</label>
                                <a id="Delete_Question'.$counter.'" db-id="'.$question_id.'" style="float: right;font-size: 19px;" href="javascript:;" class="text-danger btnDelete " title="Delete Question" >  <i class="fas fa-trash p-1"></i></a>

                            </div>
                            <div class="col-lg-4 pt-1">
                                <label class="font-weight-bold">Type of response</label>

                            </div>
                        </div>
                    </div>
                    <div class="card-body ">
                        <div class="row ">
                            <div class="col-lg-8">
                                <input type="text" class="form-control" name="question[]" id="question'.$counter.'" placeholder="" required value="'.Question::where('id',$question_id)->pluck('question')->first().'">
                                <input type="hidden" class="form-control" name="response_id[]"  id="question_responses'.$counter.'" value="'.$response_id.'" >
                                <input type="hidden" class="form-control"  name="input"  id="input'.$counter.'" value="'.$input.'" >

                                <div class="row border-bottom p-2">
                                    <div class="col-sm-12 question_response_option'.$counter.'">

                                    '.$response_html.'

                                    </div>
                                    <div class="col-sm-12 text-danger" style="display:none;" id="question_response_error_html'.$counter.'">
                                        * Please choose response for the question
                                    </div>
                                </div>
                            </div>
                            <div class="col-lg-2 ">

                            <div class="form-group mb-0 justify-content-end pt-1">
                            <input type="checkbox" id="'.$counter.'" class=" btn-choose-input" data-checkboxes="mygroup">
                            <label for="checkbox-2"  class="font-weight-bold " style="font-size:18px">input text field</label>
                        </div>

                        </div>
                        <div class="col-lg-2 ">

                        <button id="choose'.$counter.'" attr-id="btn-choose" choose-id="'.$counter.'" class="btn btn-primary btn-block text-white btn-choose-response" data-bs-toggle="modal" data-bs-target="#myModal2"
                            role="button">Choose response</button>

                        </div>
                        </div>
                    </div>
                    <div class="card-footer tx-medium border border-dark" style="background-color:#f7f7f7;">
                        <input type="hidden" name="counter[]" value="'.$counter.'">
                        <div class="row">
                            <div class="col-lg-2 border-dark border-end pt-1 font-weight-bold">
                                <label for="" class="checkbox-span text-danger add-logic" id="add-logic'.$counter.'"> <i
                                        class="typcn typcn-flow-children pr-2 "></i>
                                    Add logic</label>
                            </div>
                            <div class="col-lg-2 border-dark border-end">
                                <div class="form-group mb-0 justify-content-end pt-1">
                                    <input type="checkbox" name="is_required'.$counter.'"  id="is_required'.$counter.'" '.$is_required.' data-checkboxes="mygroup">
                                    <label for="checkbox-2"  class="font-weight-bold ">Required</label>
                                </div>
                            </div>
                            <div class="col-lg-2 border-dark border-end">
                                <div class="form-group mb-0 justify-content-end pt-1">
                                    <input type="checkbox" name="is_multiple'.$counter.'"  id="is_multiple'.$counter.'" '.$is_multiple.'  data-checkboxes="mygroup" >
                                    <label for="checkbox-3"  class=" font-weight-bold ">Multiple selection</label>
                                </div>
                            </div>

                        </div>
                    </div>
                    <div class=" card-body tx-medium" id="div-add-logic'.$counter.'" style="background-color:#f7f7f7; display:none;">
                        <span class="text-muted">if answer </span>
                        <span class="text-primary"> is
                        </span>
                        <select class="dropdown question_response_html'.$counter.'" style="text-align:center"  name="response'.$counter.'">

                        '.$response_options.'
                        </select>
                        <span class="text-muted">then</span>
                        <select class="dropdown1 trigger" id="trigger'.$counter.'" name="trigger'.$counter.'">
                        <option value="" selected disabled>+ triger</option>
                        <option value="required_action" '.($trigger_response->logic_trigger==0 ? 'selected' : '').'> Required action</option>
                        <option value="ask_question" '.($trigger_response->logic_trigger==1 ? 'selected' : '').'>Ask a questions</option>
                        </select>
                    </div>

                </div>

                <div class="row row-sm" id="logic_question'.$counter.'" style="display:'.($child ? 'display': 'none').'; margin-left:5%">
                '.($child ? self::getQuestion($child["polling_id"],$child["id"],$this->editCounter++): '').'
                </div>

            </div>';
        return $html;
    }

     public function Delete_poll_question($id)
     {
         $question=Question::where('id',$id)->first();
         $question->delete();
         return response()->json(['status'=>'success','msg'=>'Poll Question Deleted Successfully',]);

     }

    public function updatequestion(Request $request)
    {
        $questions=$request->question;

        $isAdded = false;
        $dataTesting = array();
        $dataArr = array();
        $parents = array();
        $d = 0;
        $child = 0;

        foreach($questions as $key=>$value){

            if($request["parent_question".$request->counter[$key]] == ''){
                $dataArr["parents"][] = $request->counter[$key];

                $dataArr["child"][$d]["question"] = $request->counter[$key];

                $dataArr["child"][$d]["parent_question"] = '';
                $dataArr["child"][$d++]["question_id"] = $request["question_id".$request->counter[$key]];
            }else{
                $dataArr["child"][$d]["question"] = $request->counter[$key];
                $dataArr["child"][$d]["parent_question"] = $request["parent_question".$request->counter[$key]];
                $dataArr["child"][$d++]["question_id"] = $request["question_id".$request->counter[$key]];
            }

        }


        $finalArr = array();
        $f = 0;
        $qId = array();

        foreach ($dataArr["child"] as $key => $parent) {

            $question_id = $parent["question_id"];
            $qId[] = $question_id;



            if($question_id == 0){
                $parent = $parent["question"];
                $question =new Question();
                $question->question=$request->question[$key];
                $question->polling_id=$request->polling_id;
                $question->input = $request->input;
                $question->response_id=$request->response_id[$key];
                $question->response= isset($request["response".$request->counter[$key]]) ? $request["response".$request->counter[$key]] : '';
                $question->parent_question='';
                $question->is_required = isset($request["is_required".$request->counter[$key]]) ? 1 : 0;
                $question->logic_trigger=isset($request["trigger".$request->counter[$key]]) ? 1 : 0;;
                $question->is_multiple = isset($request["is_multiple".$request->counter[$key]]) ? 1 : 0;

                $question->is_action_required=$request->is_action_required;
                $question->schedule_Date=$request->schedule_Date;
                $question->save();
                $lastId = $question->id;
                $dataArr["child"][$key]["db_id"] = $question->id;

            }else{
                $question_id = $parent["question_id"];
                $question = Question::where('polling_id',$request->polling_id)->where('id',$question_id)->first();
                $question->question=$request->question[$key];
                $question->input = $request->input;

                $question->response_id=$request->response_id[$key];
                $question->is_required = isset($request["is_required".$request->counter[$key]]) ? 1 : 0;
                $question->logic_trigger=isset($request["trigger".$request->counter[$key]]) ? 1 : 0;
                $question->is_multiple = isset($request["is_multiple".$request->counter[$key]]) ? 1 : 0;

                $question->is_action_required=$request->is_action_required;
                $question->schedule_Date=$request->schedule_Date;
                $question->save();
                $lastId = $question->id;
                $dataArr["child"][$key]["db_id"] = $question->id;

            }

        }
        foreach ($dataArr["child"] as $key => $parent) {
            $db_id = $parent["db_id"];
            $parent_question = $parent["parent_question"];
            $parent_id = '';
            if($parent["parent_question"] != ''){
                foreach ($dataArr["child"] as $k => $child) {
                    if($child["question"] == $parent_question){
                        $parent_id = $child["db_id"];
                    }
                }
            }
            $dataArr["child"][$key]["parent_id"] = $parent_id;
            $question=Question::find($db_id);
            $question->parent_question=$parent_id;
            $question->save();
            $polling = PollingList::where('id',$question->polling_id)->first();
            $polling ->polling_name =$request->polling_name;
            $polling ->poll_closing_time = $request->poll_closing_time  ;
            $polling ->poll_closing_date = $request->poll_closing_date ;
            $polling->save();

            $isAdded = true;




        }

        if($isAdded)
        {
            return response()->json(['status'=>'success','msg'=>'Poll Questions Updated Successfully','data'=>$dataArr]);
        }else{
            return response()->json(['status'=>'fail','msg'=>'Something Went Wrong ','data'=>$dataArr]);
        }

    }

    // Responses
    public function getresponse()
    {
        $html="";

        $responses=QuestionResponse::where('client_id',auth()->user()->id)->get();
        foreach($responses as $response)
        {
            $options = "";
            foreach(json_decode($response->response) as $value)
            {
                $options .= '<span class="badge rounded-pill bg-success">'.ucwords($value).'</span>&nbsp;&nbsp;';
            }

            $html .= '<div class="row border-bottom p-2">
                <div class="col-sm-10"><a href="javascript:;" style="text-decoration:none;"  class="question-response" id="'.$response->id.'" ><div class="w-100">'.$options.'</div></a></div>
                <div class="col-sm-2">
                    <span style="float:right">
                        <a href="javascript:;" id="'.$response->id.'" role="button" title="Update Response" class="editBtn" data-bs-toggle="modal" data-bs-target="#editResponseModal">
                            <i class="fas fa-pencil-alt"></i>
                        </a>
                    </span>
                </div>
            </div>';
        }

        return response()->json(['status'=>'success','msg'=>'Successfully','html'=>$html]);
    }


    public function delete_response($id)
    {
      $response = QuestionResponse::find($id);
      $response->delete();
      return response()->json(['status'=>'success','msg'=>'Deleted Successfully']);

    }

    public function questionresponse($id)
    {
        $response=QuestionResponse::find($id);
        $options = '';
        $option = '';
        foreach(json_decode($response->response) as $value)
        {
            $option .= '<span class="badge rounded-pill bg-success">'.ucwords($value).'</span>&nbsp;&nbsp;';
            $options .= '<option value="'.($value).'"> '.($value).' </option>';

        }
        $options .= '';

        return response()->json(['status'=>'success','msg'=>'Successfully','html'=>$options,'htmltwo'=>$option]);

    }

    public function inputresponse($counter)
    {
        $option = '<span class="badge rounded-pill bg-success">input</span>&nbsp;&nbsp;';

        return response()->json(['status'=>'success','msg'=>'Successfully','html'=>$option]);

    }

       //Predefined Questions
    public function builtin_question(Request $request)
    {
        $type=$request->type;
        $html="";

        $questions=Question::where('role','Admin')->get();
        // $counter=$request->counter;
        foreach($questions as $question)
        {

            $is_required=Question::where('id',$question->id)->pluck('is_required')->first()== 1 ? 'checked' : '';
            $is_multiple=Question::where('id',$question->id)->pluck('is_multiple')->first()== 1 ? 'checked' : '';
            $trigger_ask_question=Question::where('id',$question->id)->pluck('logic_trigger')->first() == 1 ? 'selected' : '';
            $trigger=Question::where('id',$question->id)->pluck('logic_trigger')->first() == 0 ? 'selected' : '';
            $response_id=Question::where('id',$question->id)->pluck('response_id')->first();
            $response_name=QuestionResponse::where('id',$response_id)->pluck('response')->first();
            $trigger_response=Question::where('id',$question->id)->first();
            $arr_responses=json_decode($response_name);
            $response_html = "";
            $response_options = "";

            if($question->id)
            {
                $display='d-none';
            }

            $input= '';
            if($response_id!=NULL)
            {
                foreach($arr_responses as $response)
                {
                    $response_html .= '<span class="badge rounded-pill bg-success">'.ucwords($response).'</span>&nbsp;&nbsp;';
                    $response_options .= '<option value="'.$response.'" '.($trigger_response->response==$response ? 'selected' : ''). '>'.ucwords($response).'</option>';
                }
            }else{

                     $input= 'input';
                    $response_html .= '<span class="badge rounded-pill bg-success">'.ucwords('input').'</span>&nbsp;&nbsp;';



            }

            $html.='<div class="col-lg-12">
                        <input type="hidden" name="parent_question" id="parent_question" value="">
                        <input type="hidden" name="question_id" id="question_id" value="0">
                        <div class="card shadow-none" id="ParentQuestion">
                            <div class="card-header border border-dark" style="background-color:#f7f7f7;">
                                <div class="row p-0 m-0">

                                    <div class="col-lg-8  border-dark border-end pt-1">
                                        <labbel class="font-weight-bold">Question</label>

                                    <a id="Delete_Question" style="float: right;font-size: 19px;" href="javascript:;" class="text-danger btnDelete" title="Delete Question">  <i class="fas fa-trash p-1"></i></a>

                                    </div>
                                    <div class="col-lg-4 pt-1">
                                        <label class="font-weight-bold">Type of response</label>
                                    </div>
                                </div>
                            </div>
                            <div class="card-body ">
                                <div class="row ">
                                    <div class="col-lg-12">
                                        <input type="text" class="form-control" name="question[]" value="'.$question->question.'" placeholder="Enter question" required>
                                        <input type="hidden" class="form-control" name="response_id[]"  id="question_responses" >
                                        <input type="hidden" class="form-control"  name="input"  id="input'.$question->id.'" value="'.$input.'">
                                        <div class="row border-bottom p-2">
                                        <div class="col-sm-12 question_response_option'.$question->id.'">

                                        '.$response_html.'

                                        </div>
                                        <div class="col-sm-12 text-danger" style="display:none;" id="question_response_error_html'.$question->id.'">
                                            * Please choose response for the question
                                        </div>
                                    </div>
                                    </div>

                                </div>
                            </div>
                            <div class="card-footer tx-medium border border-dark" style="background-color:#f7f7f7;">
                                <input type="hidden" nam" value="">
                                <div class="row">
                                    <div class="col-lg-2 border-dark border-end pt-1 font-weight-bold">
                                        <label for="" class="checkbox-span text-danger add-logic" id="add-logic"> <i
                                                class="typcn typcn-flow-children pr-2 "></i>
                                            Add logic</label>
                                    </div>
                                    <div class="col-lg-2 border-dark border-end">
                                        <div class="form-group mb-0 justify-content-end pt-1">
                                            <input type="checkbox" name="is_required" '.$is_required.'  id="is_required" data-checkboxes="mygroup">
                                            <label for="checkbox-2"  class="font-weight-bold ">Required</label>
                                        </div>
                                    </div>
                                    <div class="col-lg-2 border-dark border-end">
                                        <div class="form-group mb-0 justify-content-end pt-1">
                                            <input type="checkbox" name="is_multiple" '.$is_multiple.'  id="is_multiple" data-checkboxes="mygroup" >
                                            <label for="checkbox-3"  class=" font-weight-bold ">Multiple selection</label>
                                        </div>
                                    </div>


                                </div>
                            </div>
                            <div class=" card-body tx-medium" id="div-add-logic'.$question->id.'" style="background-color:#f7f7f7; display:none;">
                                <span class="text-muted">if answer </span>
                                <span class="text-primary"> is
                                </span>
                                <select class="dropdown question_response_html'.$question->id.'" style="text-align:center"  name="response'.$question->id.'">

                                '.$response_options.'
                                </select>
                                <span class="text-muted">then</span>
                                <select class="dropdown1 trigger" id="trigger'.$question->id.'" name="trigger'.$question->id.'">
                                <option value="" selected disabled>+ triger</option>
                                <option value="required_action" '.($trigger_response->logic_trigger==0 ? 'selected' : '').'> Required action</option>
                                <option value="ask_question" '.($trigger_response->logic_trigger==1 ? 'selected' : '').'>Ask a questions</option>
                                </select>
                            </div>
                              <small questionType="'.$type.'" class="btn btn-info add_question mt-1 mb-1" style="width:150px;" id="'.$question->id.'"> <i class="fa fa-plus"></i> Add Question</small>

                        </div>

                </div>'
            ;
        }


        return response()->json(['status'=>'success','msg'=>'Successfully','html'=>$html,'type'=>$type]);

    }

    public function question_predefined(Request $request,$id)
    {
        $counter=$request->counter;

        $html="";

        $questions=Question::where('role','Admin')->where('id',$id)->get();

        foreach($questions as $question)
        {
            $is_required=Question::where('id',$question->id)->pluck('is_required')->first()== 1 ? 'checked' : '';
            $is_multiple=Question::where('id',$question->id)->pluck('is_multiple')->first()== 1 ? 'checked' : '';
            $trigger_ask_question=Question::where('id',$question->id)->pluck('logic_trigger')->first() == 1 ? 'selected' : '';
            $trigger=Question::where('id',$question->id)->pluck('logic_trigger')->first() == 0 ? 'selected' : '';
            $response_id=Question::where('id',$question->id)->pluck('response_id')->first();
            $response_name=QuestionResponse::where('id',$response_id)->pluck('response')->first();
            $trigger_response=Question::where('id',$question->id)->first();
            $arr_responses=json_decode($response_name);
            $response_html = "";
            $response_options = "";

            if($question->id)
            {
                $display='d-none';
            }

            $input= '';
            if($response_id!=NULL)
            {
                foreach($arr_responses as $response)
                {
                    $response_html .= '<span class="badge rounded-pill bg-success">'.ucwords($response).'</span>&nbsp;&nbsp;';
                    $response_options .= '<option value="'.$response.'" '.($trigger_response->response==$response ? 'selected' : ''). '>'.ucwords($response).'</option>';
                }
            }
            else
            {
                $input= 'input';
                $response_html .= '<span class="badge rounded-pill bg-success">'.ucwords('input').'</span>&nbsp;&nbsp;';
            }

            $html.='<div class="col-lg-12">
                        <input type="hidden" name="parent_question'.$counter.'" id="parent_question'.$counter.'" value="">
                        <input type="hidden" name="question_id'.$counter.'" id="question_id'.$counter.'" value="0">
                        <div class="card shadow-none" id="ParentQuestion'.$counter.'">
                            <div class="card-header border border-dark" style="background-color:#f7f7f7;">
                                <div class="row p-0 m-0">

                                    <div class="col-lg-8  border-dark border-end pt-1">
                                        <labbel class="font-weight-bold">Question</label>

                                    <a id="Delete_Question'.$counter.'" style="float: right;font-size: 19px;" href="javascript:;" class="text-danger btnDelete" title="Delete Question">  <i class="fas fa-trash p-1"></i></a>

                                    </div>
                                    <div class="col-lg-4 pt-1">
                                        <label class="font-weight-bold">Type of response</label>
                                    </div>
                                </div>
                            </div>
                            <div class="card-body ">
                                <div class="row ">
                                    <div class="col-lg-8">
                                        <input type="text" class="form-control" name="question[]" value="'.$question->question.'" placeholder="Enter question" required>
                                        <input type="hidden" class="form-control" name="response_id[]"  id="question_responses'.$counter.'" value="'.$response_id.'" >
                                        <input type="hidden" class="form-control"  name="input"  id="input'.$counter.'" value="'.$input.'">

                                        <div class="row border-bottom p-2">
                                        <div class="col-sm-12 question_response_option'.$counter.'">

                                        '.$response_html.'

                                        </div>
                                        <div class="col-sm-12 text-danger" style="display:none;" id="question_response_error_html'.$counter.'">
                                            * Please choose response for the question
                                        </div>
                                    </div>
                                    </div>
                                    <div class="col-lg-2 ">

                                        <div class="form-group mb-0 justify-content-end pt-1">
                                        <input type="checkbox" id="'.$counter.'" class=" btn-choose-input"    data-checkboxes="mygroup">
                                        <label for="checkbox-2"  class="font-weight-bold " style="font-size:18px">input text field</label>
                                    </div>


                                    </div>
                                    <div class="col-lg-2 ">

                                    <button id="choose'.$counter.'" attr-id="btn-choose" choose-id="'.$counter.'" class="btn btn-primary btn-block text-white btn-choose-response" data-bs-toggle="modal" data-bs-target="#myModal2"
                                        role="button">Choose response</button>

                                    </div>
                                </div>
                            </div>
                            <div class="card-footer tx-medium border border-dark" style="background-color:#f7f7f7;">
                            <input type="hidden" name="counter[]" value="'.$counter.'">
                                <div class="row">
                                    <div class="col-lg-2 border-dark border-end pt-1 font-weight-bold">
                                        <label for="" class="checkbox-span text-danger add-logic" id="add-logic'.$counter.'"> <i
                                                class="typcn typcn-flow-children pr-2 "></i>
                                            Add logic</label>
                                    </div>
                                    <div class="col-lg-2 border-dark border-end">
                                        <div class="form-group mb-0 justify-content-end pt-1">
                                            <input type="checkbox" name="is_required" '.$is_required.'  id="is_required" data-checkboxes="mygroup">
                                            <label for="checkbox-2"  class="font-weight-bold ">Required</label>
                                        </div>
                                    </div>
                                    <div class="col-lg-2 border-dark border-end">
                                        <div class="form-group mb-0 justify-content-end pt-1">
                                            <input type="checkbox" name="is_multiple" '.$is_multiple.'  id="is_multiple" data-checkboxes="mygroup" >
                                            <label for="checkbox-3"  class=" font-weight-bold ">Multiple selection</label>
                                        </div>
                                    </div>


                                </div>
                            </div>
                            <div class=" card-body tx-medium" id="div-add-logic'.$counter.'" style="background-color:#f7f7f7; display:none;">
                                <span class="text-muted">if answer </span>
                                <span class="text-primary"> is
                                </span>
                                <select class="dropdown question_response_html'.$counter.'" style="text-align:center"  name="response'.$counter.'">

                                '.$response_options.'
                                </select>
                                <span class="text-muted">then</span>
                                <select class="dropdown1 trigger" id="trigger'.$counter.'" name="trigger'.$counter.'">
                                <option value="" selected disabled>+ triger</option>
                                <option value="required_action" '.($trigger_response->logic_trigger==0 ? 'selected' : '').'> Required action</option>
                                <option value="ask_question" '.($trigger_response->logic_trigger==1 ? 'selected' : '').'>Ask a questions</option>
                                </select>
                            </div>

                        </div>

                        <div class="row row-sm childquestion" id="logic_question'.$counter.'" style="display:none; margin-left:5%">

                        </div>

                </div>'
            ;
        }

        return response()->json(['status'=>'success','msg'=>'Successfully','html'=>$html,'counter'=>$counter]);




    }

    public function addresponse(Request $request)
    {

        $responses=$request->response;

            $response=new QuestionResponse();

          $value=[];

          if($request->response){
               foreach($request->response as $key){

                 array_push($value, $key);

               }

             $response->response=json_encode($value);

          }
            $response->color=$request->color;
            $response->score=$request->score;
            $response->is_failed=$request->is_failed;
            $response->client_id=Auth::id();

        if($response->save())
        {
            return response()->json(['status'=>'success','msg'=>'Response Added Successfully']);
        }else{
            return response()->json(['status'=>'fail','msg'=>'Something Went Wrong ']);
        }


    }

    public function editresponse($id)
    {
        $data = QuestionResponse::find($id);

        $responses = array();
        if ($data->response != NULL)
        {
            $responses = json_decode($data->response);
        }

        if(sizeof($responses) > 0)
        {
            // dd('yes');
            return response()->json([
                'status'=>'success',
                'msg'=>'Responses has been found',
                'data'=>$data,
                'responses'=>$responses
            ]);
        }
        else
        {
            // dd('no');
            return response()->json([
                'status'=>'fail',
                'msg'=>'No response are found',
                'data'=>'','responses'=>''
            ]);
        }

    }

    public function updateresponse(Request $request)
    {
        // dd($request->all());
        $responses = $request->edit_response;
        $response = QuestionResponse::find($request->editResponseId);
        // dd($request->editResponseId);

        $value=[];

        if($responses != NULL)
        {
            foreach($responses as $key)
            {
                array_push($value, $key);
            }
            $response->response=json_encode($value);
        }
        // dd();

        $response->color = isset($request->color) ? $request->color : NULL;
        $response->score = isset($request->score) ? $request->score : NULL;
        $response->is_failed = isset($request->is_failed) ? $request->is_failed : NULL;

        if($response->save())
        {
            return response()->json(['status'=>'success','msg'=>'Response Updated Successfully']);
        }
        else
        {
            return response()->json(['status'=>'fail','msg'=>'Something Went Wrong ']);
        }
    }

    // ./Responses
    //Front side Questionare


    // public function questionnaire(Request $request, $questioncode)
    // {

    public function questionnaire(Request $request, $questioncode)
    {
        try
        {
            $polling_data = PollingList::where('token', $questioncode)->with(['questions' => function($query){
                $query->whereNull('parent_question');
            }])->first();

            // dd($polling_data);

            if(isset($polling_data) && $polling_data != NULL)
            {
                $client=$polling_data->client_id;
                $parentQuestions = $polling_data->questions;
                $question_id = array();
                foreach($parentQuestions as $key => $polling_question)
                {
                    $question_id[] = $polling_question->id;
                }

                $question_ids = json_encode($question_id);

                // $clientid=$polling_data;
                $polling_id=$polling_data->id;
                $polling_name=$polling_data->polling_name;
                $user=User::where('id', $client)->first();
                $question_id=Question::where('polling_id',$polling_data->id)->count();
                $geo = geoip()->getLocation(\Request::ip());

                //polling_qrcode_hits table
                $PollingBefore = PollingBefore::Create([
                'Ip_address' => $request->ip(),
                'location_name' => $geo->city,
                'longitude' => $geo->lon,
                'latitude' => $geo->lat,
                'polling_id' => $polling_data->id,
                'client_id' => $client,
                ]);

                $polling=$PollingBefore->id;
                $code = $polling_data;
                return view('dashboard.questionnaire', compact('polling_name','user','code','polling','question_id','polling_id', 'parentQuestions', 'question_ids'));
                // 'questions',
            }
            else
            {
                return view('404-2');
            }
        }
        catch(Exception $e)
        {
            return response()->json(['success' => false , 'msg' => 'Something Went Wrong While Adding Polling' , 'error' => $e->getMessage() ]);
        }
    }

    public function thanks()
    {
        return view('poll.Thanks');
    }

    //if yes

    public function Save_Result_Form(Request $request)
    {
        $result=new Get_Result();
        $result->first_name=$request->first_name;
        $result->last_name=$request->last_name;
        $result->email=$request->email;
        $result->phone=$request->phone;
        $result->client_id=$request->client_id;
        $result->polling_id=$request->polling_id;
        $result->save();

        $follower =  new Follower();
        $follower->first_name=$result->first_name;
        $follower->last_name=$result->last_name;
        $follower->email=$result->email;
        $follower->phone=$result->phone;
        $follower->client_id=$result->client_id;
        $follower->source='polling';
        $follower->source_id=$result->id;
        $follower->save();

        if($result->save())
        {
            return response()->json(['status'=>'success','msg'=>'Submited Successfully']);
        }else{
            return response()->json(['status'=>'fail','msg'=>'Something Went Wrong ']);
        }
    }

    public function add_polling_answer(Request $request)
    {
        try
        {
            $pollingId = $request->pollingId;
            $clientId = $request->clientId;
            $qrId = $request->qrId;
            $answers= $request->answers;
            $respondedAnswer = [];
            foreach($answers as $answer)
            {
                if($answer['type'] == 'ranking')
                {
                    $top_value = explode('&&', $answer['answer']);
                    $respondedAnswer[] = [
                        'polling_qrcode_id' => $qrId,
                        'parent_id' => $answer['parentId'] ,
                        'question_id' => $answer['questionId'] ?? null,
                        'response' => $answer['answer'],
                        'response_id' => $answer['responseId'],
                        'top_value' => $top_value[0], //first array of top value
                        'response_type' => $answer['type'],
                        'polling_id' => $pollingId,
                        'client_id' => $clientId,
                    ];
                }
                else
                {
                    $respondedAnswer[] = [
                        'polling_qrcode_id' => $qrId,
                        'parent_id' => $answer['parentId'] ,
                        'question_id' => $answer['questionId'] ?? null,
                        'response' => $answer['answer'],
                        'response_id' => $answer['responseId'],
                        'top_value' => 0, //first array of top value
                        'response_type' => $answer['type'],
                        'polling_id' => $pollingId,
                        'client_id' => $clientId,
                    ];
                }
            }

            PollingQuestion::insert($respondedAnswer);

            PollingBefore::where('id', $qrId)->update([
                'is_form_submited' => 1
            ]);

            return response()->json(['success' => true , 'msg' => 'Successfully Submitted Polling' ]);
        }
        catch(Exception $e)
        {
            return response()->json(['success' => false , 'msg' => 'Something Went Wrong While Adding Polling' , 'error' => $e->getMessage() ]);
        }
    }

    public function logic_trigger(Request $request)
    {
        try{
        $questionId = $request->questionId;
        $value = $request->value;
        $parentQuestion = Question::where('id' , $questionId)->where('response' , $value)->first();
        if(isset($parentQuestion) && !empty($parentQuestion))
        {
            $question = Question::where('parent_question' , $questionId)->first();
            $view = $this->get_input_view($question->input , $question);
            return response()->json(['success' => true , 'trigger' => true , 'logic' => $view ]);

        } else {
            return response()->json(['success' => false , 'trigger' => false, 'msg' => 'No trigger found']);
        }
    }catch(Exception $e)
    {
        return response()->json(['success' => false , 'msg' => 'Something Went Wrong' , 'error' => $e->getMessage()]);
    }

    }

    public function get_input_view($type , $polling_question)
    {
        if($type == 'text') {
            $view = view('poll.components.text-input' , ['polling_question'=>$polling_question , 'key' => 0 , 'trigger' => true])->render();
            return $view;
        }
        else if($type == 'ranking') {
            $view = view('poll.components.ranking' , ['polling_question'=>$polling_question , 'key' => 0 , 'trigger' => true])->render();
            return $view;
        }
        else if($type == 'rating') {
            $view = view('poll.components.ranking' , ['polling_question'=>$polling_question , 'key' => 0 , 'trigger' => true])->render();
            return $view;
        }
        else if($type == 'true / false')
        {
            $view = view('poll.components.true-false' , ['polling_question'=>$polling_question , 'key' => 0 , 'trigger' => true])->render();
            return $view;
        }
        else {
            $view = view('poll.components.radio-input' , ['polling_question'=>$polling_question , 'key' => 0 , 'trigger' => true])->render();
            return $view;
        }
    }

    public function thanks_polling()
    {
        return view('dashboard.thankyou');
    }



    public function pollQuestions($polling_id)
    {
        $parentQuestions = Question::where('polling_id',$polling_id)->where('parent_question','')->get();
        // dd($parentQuestions);
        $html = "";
        foreach ($parentQuestions as $key => $parent)
        {
            $html .= self::pollQuestionsHTML($key,$parent,false);
        }

        return response()->json(['status'=>'success','msg'=>'Successfully','parents' => $parentQuestions,'html'=>$html,'counter'=>$this->editCounter]);
    }

    public function pollQuestionsHTML($q_key,$question,$is_child)
    {
        $questionId = $question->id;
        $childQuestion = Question::where('polling_id',$question->polling_id)->where('parent_question',$questionId)->first();
        $response = QuestionResponse::where('id',$question->response_id)->first();

        // dd($response);

        if($response!=NULL)
        {
            $arr_responses=json_decode($response->response);

            $response_html = $question["is_required"] == 1 &&  $question->is_multiple == 1 ? ' <input type="hidden" name="is_required_multiple[]" id="is_required_multiple'.$questionId.'" value="'.$questionId.'">' : '';
            $i=0;

            foreach($arr_responses as $k => $response_name)
            {
                $response_html.='<div class="checkbox">
                    <input type="hidden" class="is_required" id="is_required'.$questionId.'" value="'.$question["is_required"].'">

                    <div class="custom-checkbox custom-control px-1 text-muted mb-0 tx-13 small">
                        <label class="checkbox p-0"><input value="'.$response_name.'" class="question"
                            type="'.($question->is_multiple == 1 ? 'checkbox' : 'radio').'" db-id="'.$questionId.'" name="radio_response_id'.$question["id"].'[]'.'"
                                id="radio_response_id'.$questionId.$k.'" '.($question["is_required"] == 1 &&  $question->is_multiple == 0 && !$is_child ? 'required' : '').'> '.ucwords($response_name).'

                    </div>
                    <input type="hidden" id="multiple_checkbox'.$questionId.'" value="'.$question->is_multiple.'">

                </div>';
            }

            $html = '<div class="col-lg-12" id="divQuestion'.$question["id"].'" style="display: '.($is_child ? 'none' : 'block').'">
                    <div class="card-body pb-0">
                        <h4 class="fw-semibold tx-14">Q'.($q_key +1).': '.$question["question"].' '.($question["is_required"] == 1 ? '<span class="text-danger">*</span>' : '').'
                        </h4>
                        <div class="">

                            <input type="hidden" name="polling_id" value="'.$question["polling_id"].'">
                            <input type="hidden" name="question_id[]" value="'.$question["id"].'">
                            <input type="hidden" name="response_id" value="'.$question["response_id"].'">
                            <input type="hidden" name="response_type'.$question["id"].'" value="'.($question["is_multiple"] == 1 ? 'checkbox' : 'radio').'">
                            <input type="hidden" name="parent_id'.$question["parent_question"].'" value="'.$question["parent_question"].'">
                            <input type="hidden" id="child'.$questionId.'" value="'.($childQuestion ? $childQuestion->id : 0).'">
                            <input type="hidden" id="is_required'.$questionId.'" value="'.$question["is_required"].'">
                            <input type="hidden" id="logic_trigger'.$questionId.'" value="'.$question["logic_trigger"].'">
                            <input type="hidden" id="logic_response'.$questionId.'" value="'.$question["response"].'">

                            <div class="d-flex">
                                '.$response_html.'
                            </div>

                            <div><span id="required_error'.$questionId.'" style="display:none; color: red;">*Required field</span></div>

                            </div>

                            <div class="row" id="child">
                                '.($childQuestion ? self::pollQuestionsHTML($q_key,$childQuestion,true) : '').'
                            </div>

                        </div>
                    </div>
                </div>';

            return $html;
        }
        else
        {
            $response_html = $question["is_required"] == 1 &&  $question->is_multiple == 1 ? ' <input type="hidden" name="is_required_multiple[]" id="is_required_multiple'.$questionId.'" value="'.$questionId.'">' : '';
            $i=0;

            $response_html.='<div class="checkbox">
                <input type="hidden" class="is_required" id="is_required'.$questionId.'" value="'.$question["is_required"].'">

                <div class="custom-checkbox custom-control px-1 text-muted mb-0 tx-13 small">
                    <label class="checkbox p-0"><input  class="question form-control"
                        type="text"  db-id="'.$questionId.'" placeholder="'.$question["question"].'" name="radio_response_id'.$question["id"].'"
                            id="radio_response_id'.$questionId.'" '.($question["is_required"] == 1 && !$is_child ? 'required' : '').'>

                </div>
                <input type="hidden" id="multiple_checkbox'.$questionId.'" value="'.$question->is_multiple.'">

            </div>';

            $html = '<div class="col-lg-12" id="divQuestion'.$question["id"].'" style="display: '.($is_child ? 'none' : 'block').'">
                    <div class="card-body pb-0">
                        <h4 class="fw-semibold tx-14">Q'.($q_key +1).': '.$question["question"].' '.($question["is_required"] == 1 ? '<span class="text-danger">*</span>' : '').'
                        </h4>
                        <div class="">

                            <input type="hidden" name="polling_id" value="'.$question["polling_id"].'">
                            <input type="hidden" name="question_id[]" value="'.$question["id"].'">
                            <input type="hidden" name="response_id" value="'.$question["response_id"].'">
                            <input type="hidden" name="response_type'.$question["id"].'" value="input">
                            <input type="hidden" name="parent_id'.$question["parent_question"].'" value="'.$question["parent_question"].'">
                            <input type="hidden" id="child'.$questionId.'" value="'.($childQuestion ? $childQuestion->id : 0).'">
                            <input type="hidden" id="is_required'.$questionId.'" value="'.$question["is_required"].'">
                            <input type="hidden" id="logic_trigger'.$questionId.'" value="'.$question["logic_trigger"].'">
                            <input type="hidden" id="logic_response'.$questionId.'" value="'.$question["response"].'">

                            <div class="d-flex">
                                '.$response_html.'
                            </div>

                            <div><span id="required_error'.$questionId.'" style="display:none; color: red;">*Required field</span></div>

                            </div>

                            <div class="row" id="child">
                                '.($childQuestion ? self::pollQuestionsHTML($q_key,$childQuestion,true) : '').'
                            </div>

                        </div>
                    </div>
                </div>';

            return $html;
        }
    }

    public function savePollingQuestion(Request $request)
    {
        // dd($request->all());
        $questions = $request->question_id;

        $isAdded = true;
        $data = array();
        foreach($questions as $key=>$value)
        {
            $pollingQuestion=new PollingQuestion();
            $pollingQuestion->polling_id=$request->polling_id;
            $pollingQuestion->parent_id=$request["parent_id".$value];
            $pollingQuestion->polling_qrcode_id=$request->polling_qrcode_id;
            $pollingQuestion->question_id=$value;

            $pollingQuestion->client_id=$request->client_id;
            $pollingQuestion->response_id= $value;//$request->response_id;
            $pollingQuestion->response_type=$request["response_type".$value];

            if($request["response_type".$value] == 'input')
            {
                $pollingQuestion->response=isset($request["radio_response_id".$value]) ? $request["radio_response_id".$value]  : '';
            }
            else
            {
                $pollingQuestion->response=isset($request["radio_response_id".$value]) ? json_encode($request["radio_response_id".$value])  : '';
            }

            $pollingQuestion->Save();

            $polling=PollingBefore::where('id',$pollingQuestion->polling_qrcode_id)->first();
            $polling->is_form_submited=1;
            $polling->Save();
            $polling=PollingList::where('id',$pollingQuestion->polling_id)->first();
            $polling->status=2;
            $polling->Save();

            $isAdded = true;

            $data[$key]["question_id"] = $value;

            $data[$key]["response"] = isset($request["radio_response_id".$value]) ? json_encode($request["radio_response_id".$value])  : '';

        }
        if($isAdded)
        {
            return response()->json(['status'=>'success','msg'=>'Your Response has been Saved Successfully','data'=>$data]);
        }
        else
        {
            return response()->json(['status'=>'fail','msg'=>'Something Went Wrong ']);
        }
    }


    public function question_responses_list()
    {
        return view('poll.question_responses_list');
    }

    public function question_respones($id)
    {
        $questionresponses=Question::where('polling_id',$id)->get();
        $poll_name=PollingList::where('id',$id)->pluck('polling_name')->first();
        return view('poll.question_responses',compact('questionresponses','poll_name'));
    }

    public function Question_logic(Request $request)
    {
        $question_logic=new QuestionLogic();
        $question_logic->response=$request->response;
        $question_logic->action=$request->action;

        if($question_logic->Save())
        {
            return response()->json(['status'=>'success','msg'=>'Question Logic Added Successfully']);
        }
        else
        {
            return response()->json(['status'=>'fail','msg'=>'Something Went Wrong ']);
        }
    }

    public function poll_analytics()
    {
        return view('poll.poll_analytic');
    }

    public function poll_detail($id)
    {
        $role = getRole();
        if($role->hasPermissionTo('polling list view submission'))
        {
            $login_user = auth()->user();
            $value = 1;
            $polling = PollingList::where('id',$id)->where('client_id',$login_user->id)->with(['pollingListWithResponce', 'polling_question_answers', 'polling_qrcode_hits' => function ($query) use ($value) {
                $query->where('is_form_Submited', $value);
            }])->first(); //polling_list table

            $top_rating_array = array();
            foreach($polling->polling_question_answers as $answer)
            {
                if($answer->response_type == "ranking")
                {
                    $top_rating_array[$answer->top_value] = rating_answer_value_count($answer->top_value, $id);
                }
            }

            if(now()->toDateString() == $polling->poll_closing_date)
            {
                PollingList::where('id',$id)->update([
                    'status' => 1
                ]);
            }

            if($polling)
            {
                $questions = $polling->pollingListWithResponce; //get pollling_questions table entries with relationships
                $poll_name = $polling->polling_name; //get polling_name from polling_list table
                $users = User::where('client_id', $login_user->id)->get();

                $rating_responce = QuestionResponse::where('response_title', 'rating')->first();

                $trueFalse_responce = QuestionResponse::where('response_title', 'true / false')->first();
                $appUrl = env('APP_URL').'/toast/';

                return view('poll.poll_detail',compact('polling','questions','poll_name','users','rating_responce','trueFalse_responce','top_rating_array', 'appUrl','login_user'));
            }
            else
            {
                return view('404');
            }
        }
        else
        {
            return back();
        }
    }


    public function edit_notes($id)
    {
       $question_notes=Question::find($id);

       return response()->json(['status'=>'success','data'=>$question_notes]);
    }

    public function update_notes(Request $request)
    {
        // dd($request->all());
        $question_notes=Question::find($request->notes_updated_question_id);
        // dd($question_notes);
        $question_notes->notes=$request->notes;
        if($question_notes->Save())
        {
          return response()->json([
            'status'=>'success',
            'msg'=>'Notes Added Successfully',
            'note_value'=>$request->notes,
            ]);
        }
        else
        {
          return response()->json(['status'=>'fail','msg'=>'Something Went Wrong']);
        }
    }


    public function edit_polling_task($id)
    {
        $polling_assign_task=PollingQuestion::find($id);

        return response()->json(['status'=>'success','data'=>$polling_assign_task]);
    }

    public function add_polling_task(Request $request)
    {
        $polling_assign_task=new DoList();
        $polling_assign_task->title=$request->title;
        $polling_assign_task->description=$request->description;
        $polling_assign_task->status=$request->status;
        $polling_assign_task->client_id=Auth::id();
        $polling_assign_task->question_id=$request->question_id;
        $polling_assign_task->priority=$request->priority;
        $polling_assign_task->date=$request->date;

        if($request->member_id)
        {
            $polling_assign_task->member_id=json_encode($request->member_id);
        }

        $polling_assign_task->Save();

        if($polling_assign_task->Save())
        {
            $response["data"]=$polling_assign_task->id;
            return response()->json(['status'=>'success','msg'=>'Task Assign Successfully','data'=>$response["data"]]);
        }
        else
        {
            return response()->json(['status'=>'fail','msg'=>'Something Went Wrong']);
        }
    }

    public function send_email($data)
    {
        $task = DoList::where('id',$data)->first();
        $members=json_decode($task->member_id);

        foreach($members as $member)
        {
            $task = DoList::where('id',$data)->first();
            $user=User::where('id',$member)->first();
            $client=User::where('client_id',Auth::id())->first();

            // Mail::send('mails.assigntask', ['user'=>$user,'client'=>$client,'task'=>$task], function($message) use($user){
            // $message->to($user->email);
            // $message->subject('Polling Task');
            // });

            $data = ['user'=>$user,'client'=>$client,'task'=>$task];
            Mail::to($user->email)->send(new PollAssignTaskEmail($data));
        }
    }

    public function poll_question_analytics($polling_id,$question_id)
    {
        $PollingQuestion = Question::where('id',$question_id)->with('questionResponse','polling_list','polling_question_submit')->first();
        $appUrl = env('APP_URL').'/toast/';
        $array = ['rating','true / false'];
        $value_array = array();
        $top_rating_array = array();
        if(in_array($PollingQuestion->input, $array))
        {
            $responce_value = QuestionResponse::where('response_title',$PollingQuestion->input)->pluck('response')->first();
            $name_of_responce_values = json_decode($responce_value);
            foreach($name_of_responce_values as $name_of_responce_one)
            {
                $value_array[] = PollingQuestion::where('response', $name_of_responce_one)->where('polling_id', $polling_id)->count();
            }
            $count_total_values = json_encode($value_array);

        }
        elseif($PollingQuestion->input == 'ranking')
        {
            foreach($PollingQuestion->polling_question_submit as $answer)
            {
                $top_rating_array[$answer->top_value] = rating_answer_value_count($answer->top_value, $polling_id);
            }

            $responce_value = $PollingQuestion->questionResponse->response;
            $name_of_responce_values = json_decode($responce_value);
            foreach($name_of_responce_values as $key => $response)
            {
                $value_array[] = isset($top_rating_array[$response]) ? $top_rating_array[$response] : 0;
            }
            $count_total_values = json_encode($value_array);
        }
        else
        {
            $responce_value = $PollingQuestion->questionResponse->response;
            $name_of_responce_values = json_decode($responce_value);
            foreach($name_of_responce_values as $name_of_responce_one)
            {
                $value_array[] = PollingQuestion::where('response', $name_of_responce_one)->where('polling_id', $polling_id)->count();
            }
            $count_total_values = json_encode($value_array);
        }

        return view('poll.poll_analytics',compact('responce_value', 'count_total_values', 'polling_id', 'name_of_responce_values', 'value_array','PollingQuestion', 'question_id', 'appUrl', 'top_rating_array'));
    }


    public function Edit_Poll($id)
    {
        $polling=PollingList::find($id);

        return response()->json(['status'=>'success','data'=>$polling]);
    }

    public function schedule()
    {
        $response=PollingList::all();

        return response()->json(['status'=>'success','data'=>$response]);
    }

    public function update_poll(Request $request)
    {
        $polling=PollingList::find($request->id);
        if($request->schedule)
        {
            $polling->schedule=$request->schedule;
        }

        if($request->status && $request->polling_name)
        {
            $polling->status = $request->status;
            $polling->polling_name = $request->polling_name;
        }

        if($request->distributed_date && $request-> distributed_date)
        {
            $polling->distributed_date=$request->distributed_date;
            $polling->distributed_time=$request->distributed_time;
        }

        if($polling->Save())
        {
            return response()->json(['status'=>'success','msg'=>' Schedule Added Successfully']);
        }
        else
        {
            return response()->json(['status'=>'fail','msg'=>'Something Went Wrong']);
        }
    }

    public function Edit_Poll_Result($id)
    {
        $polling=PollingList::find($id);

        return response()->json(['status'=>'success','data'=>$polling]);
    }


    public function getresult(Request $request)
    {
        $html='';
        $polling=PollingList::where('client_id',Auth::id())->get();

        foreach($polling as $poll)
        {
            $status='';
            if($poll->status==0)
            {
                $status='Pending';
            }
            elseif($poll->status==1)
            {
                $status='Inprogress';
            }
            else
            {
                $status='Closed';
            }

            $html.='<tr class="tr">

            <td>'.$poll->created_at->format('M d, Y').'/'.$poll->polling_name.'</td>

                <td>
                <a href=/poll/detail/'.$poll->id.'>
                '.PollingBefore::where('client_id',Auth::id())->where('is_form_submited',1)->where('polling_id',$poll->id)->count().' submissions
                </a>
                </td>

            <td>'.$poll->poll_closing_date.'</td>
            <td>'.$status.'</td>

            <td><a class="edit-row btn btn-outline-primary p-0 px-2" data-bs-toggle="modal" id="'.$poll->id.'" data-bs-target="#exampleModal">Edit Poll</a></td>
            </tr>';

        }
        return response()->json(['status'=>'success','msg'=>'Successfully','html'=>$html]);
    }

    public function update_poll_Result(Request $request)
    {
        $polling=PollingList::find($request->id);
        if($request->polling_name)
        {
            $polling->polling_name=$request->polling_name;
        }

        $polling->status=$request->status;
        $polling->poll_closing_date=$request->poll_closing_date;

        if($polling->Save())
        {
            return response()->json(['status'=>'success','msg'=>' Updated Successfully']);
        }
        else
        {
            return response()->json(['status'=>'fail','msg'=>'Something Went Wrong']);
        }
    }

    // Analytics and Dwonload PDF
    public function download_analytic()
    {
        return view('poll.download_analytic');
    }

    public function GenereatePdf(Request $request)
    {
        $chart1=$request->chart1;
        $chart2=$request->chart2;
        $question=$request->question;
        $question_date=$request->question_date;
        $polling_name=$request->pollingname;
        // $polling_id=$request->polling_id;
        $question_id=$request->question_id;

        // dd($request->chart1);


        //suleman start code here
        // $PollingQuestion = Question::where('id',$question_id)->with('questionResponse','polling_list')->first();

        // $array = ['rating','true / false'];
        // $value_array = array();
        // $top_rating_array = array();

        // if(in_array($PollingQuestion->input, $array))
        // {
        //     $responce_value = QuestionResponse::where('response_title',$PollingQuestion->input)->pluck('response')->first();
        //     $name_of_responce_values = json_decode($responce_value);
        //     foreach($name_of_responce_values as $name_of_responce_one)
        //     {
        //         $value_array[] = PollingQuestion::where('response', $name_of_responce_one)->count();
        //     }
        //     $count_total_values = json_encode($value_array);
        // }
        // elseif($PollingQuestion->input == 'ranking')
        // {
        //     foreach($PollingQuestion->polling_question_submit as $answer)
        //     {
        //         $top_rating_array[$answer->top_value] = rating_answer_value_count($answer->top_value);
        //     }

        //     $responce_value = $PollingQuestion->questionResponse->response;
        //     $name_of_responce_values = json_decode($responce_value);

        //     foreach($name_of_responce_values as $key => $response)
        //     {
        //         $value_array[] = isset($top_rating_array[$response]) ? $top_rating_array[$response] : 0;
        //     }
        //     $count_total_values = json_encode($value_array);
        // }
        // else
        // {
        //     $responce_value = $PollingQuestion->questionResponse->response;
        //     $name_of_responce_values = json_decode($responce_value);
        //     foreach($name_of_responce_values as $name_of_responce_one)
        //     {
        //         $value_array[] = PollingQuestion::where('response', $name_of_responce_one)->count();
        //     }
        //     $count_total_values = json_encode($value_array);
        // }
        //suleman code end here

        $hash = mt_rand(999,100000);
        $time = time();
        $filename = ucwords($polling_name).'-'.$hash.'-'.$time.'.pdf';

        $pdf = PDF::loadView('poll.download_analytic',[
            'chart1'=>$chart1,
            'chart2'=>$chart2,
            'question'=>$question,
            'polling_name'=>$polling_name,
            'question_date'=>$question_date,
            // "polling_id"=>$polling_id,
            // 'question_id'=>$question_id,
            'responses'=>$question_id,
            // 'value_array'=>$value_array,
            // 'name_of_responce_values'=>$count_total_values,
            // 'count_total_values'=>$name_of_responce_values,
            // 'top_rating_array' => $top_rating_array
            ])->save(public_path('/toast/').$filename);

        return response()->json(['status'=>'success', 'filename'=>$filename]);
    }


    public function deletefile(Request $request)
    {
        $pdf=$request->file;
        $path = public_path("toast/");

        if (file_exists($path.$pdf))
        {
            @unlink($path.$pdf);
        }

        return response()->json(['status'=>'success']);
    }


    //Share
    public function Share_polling_question(Request $request)
    {
        $validator=Validator::make($request->all(),[
            'email' => 'required',
        ]);

        if($validator->fails())
        {
            return response()->json(['status'=>'fail','msg'=>$validator->errors()->all()]);
        }

        $share= new Share();
        $share->polling_id=$request->polling_id;
        $share->email=$request->email;
        $share->client_id=Auth::id();
        $share->save();
        if($share->Save())
        {
            $response["data"]=$share->polling_id;
            return response()->json(['status'=>'success','msg'=>'Shared Successfully','data'=>$response["data"]]);
        }
        else
        {
            return response()->json(['status'=>'fail','msg'=>'Something Went Wrong']);
        }
    }

    public function share_by_email($data)
    {
        $share=Share::where('polling_id',$data)->latest()->first();
        $client=Share::where('polling_id',$data)->pluck('client_id')->first();

        $token=PollingList::where('id',$share->polling_id)->pluck('token')->first();

        $client_name=User::where('id',$share->client_id)->first();

        $code=$token;
        $emails=explode(',',$share->email);
        foreach($emails as $email)
        {
            $data = ['questioncode' =>$code,'client_name'=>$client_name];

            Mail::to($email)->send(new ShareEmail($data));
        }
    }

    //poll detail show question after submission
//    public function poll_detail_questions($polling_id)
//     {
//        $parentQuestions = Question::where('polling_id',$polling_id)->where('parent_question','')->get();
//        $counter = 0;
//        $response = array();
//        $html = "";
//        foreach ($parentQuestions as $key => $parent) {
//            $html .= self::poll_detail_question_HTML($key,$parent,false);
//        }

//        return response()->json(['status'=>'success','msg'=>'Successfully','parents' => $parentQuestions,'html'=>$html,'counter'=>$this->editCounter]);
//     }

    public function poll_detail_question_HTML($q_key,$question,$is_child)
    {
        $questionId = $question["id"];
        $childQuestion = Question::where('polling_id',$question["polling_id"])->where('parent_question',$question["id"])->first();
        $response = QuestionResponse::where('id',$question["response_id"])->first();
        if($response!=NULL)
        {
            $polling_responses=PollingQuestion::where('question_id',$question["id"])->where('polling_id',$question["polling_id"])->first();

            $arr_responses=json_decode($response->response);

            $response_html="";

            $count = 0;

            foreach($arr_responses as $k => $response_name)
            {
                $count = PollingQuestion::where('polling_id',$question["polling_id"])->where('question_id',$question["id"])->where('response','LIKE','%"'.$response_name.'"%')->count();

                $response_html.='<span class="badge rounded-pill bg-success fw-bold px-2 mx-1"> '.$count.' '.$response_name.'</span>';
            }

            $html = '<div class="row">
                    <h2 class="accordion-header" id="panelsStayOpen-heading'.$question["id"].'">
                        <button class="accordion-button text-dark fw-bold " type="button" data-bs-toggle="collapse"
                            data-bs-target="#panelsStayOpen-collapse'.$question["id"].'" aria-expanded="true"
                            aria-controls="panelsStayOpen-collapse'.$question["id"].'" style="border: 1px solid lightgrey;">

                            '.$question["question"].'

                        </button>
                    </h2>
                    <div id="panelsStayOpen-collapse'.$question["id"].'" class="accordion-collapse collapse show"
                    aria-labelledby="panelsStayOpen-heading'.$question["id"].'">

                        <div class="accordion-body">
                        <div class="col-lg-12">

                        </div>
                        <div class="card bd shadow rounded">
                            <div class="card-header tx-medium px-3 pt-2  bg-white rounded">
                                <div class="row">
                                    <div class="col-lg-8">
                                        <h4 class="pt-3">
                                            '.$response_html.'
                                        </h4>
                                    </div>
                                    <div class="col-lg-4">
                                        <a href="/poll/'.$question->polling_id.'/question/'.$question->id.'" style="background-color: white; padding-top:0px"> <i class="fas fa-chart-bar"
                                                style="font-size:90px; float:right;"></i> </a>
                                    </div>
                                </div>
                            </div>
                            <div class="card-body bg-light ">
                                <div class="row pt-1">
                                    <div class="col-sm-9">
                                        <p class="mg-b-0 fw-bold text-muted pt-2"> <a id="'.$question->id.'" title="Add Notes" class="edit-row"  data-bs-toggle="modal" data-bs-target="#NotesModal"> <i
                                                class="fa fa-edit"></i> </a>
                                        </p>
                                        <p>'.$question->notes.'</p>
                                    </div>
                                    <div class="col-sm-3">
                                        <br>
                                        <span class="text-end" style="float:right; cursor:pointer;" data-bs-toggle="modal"
                                            data-bs-target="#exampleModal1">
                                            <a id="'.$question->id.'" class="edit-task" data-bs-toggle="modal"
                                            data-bs-target="#exampleModal1" style="display:'.($question->logic_trigger == 0 ? 'display': 'none').'; margin-left:5%"> <i class="fas fa-check-square mx-2 "></i> Action </a>
                                        </span>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div id="child" style="margin-left:3%">
                        '.($childQuestion ? self::poll_detail_question_HTML($q_key,$childQuestion,true) : '').'
                        </div>
                    </div>
                </div>
            </div>';

            return $html;
        }
        else
        {

            $response_html="";

            $count = 0;
            $arr_responsess=PollingQuestion::where('polling_id',$question["polling_id"])->where('question_id',$question["id"])->where('response_type','input')->first();

            $response_html.='
                    <div class="row">
                    <div class="col-lg-3"> <a href="/poll/question/responses/'.$question["id"].'" class="  fw-bold px-2 mx-1 " style="    background: cornflowerblue;
                    border-radius: 30px;
                    color: white;text-align: center;">View all Responses</a></div>
                    <div class="col-lg-9"></div>
                    </div>';

            $html = '<div class="row">
                        <h2 class="accordion-header" id="panelsStayOpen-heading'.$question["id"].'">
                            <button class="accordion-button text-dark fw-bold " type="button" data-bs-toggle="collapse"
                                data-bs-target="#panelsStayOpen-collapse'.$question["id"].'" aria-expanded="true"
                                aria-controls="panelsStayOpen-collapse'.$question["id"].'" style="border: 1px solid lightgrey;">

                                '.$question["question"].'

                            </button>
                        </h2>
                        <div id="panelsStayOpen-collapse'.$question["id"].'" class="accordion-collapse collapse show"
                        aria-labelledby="panelsStayOpen-heading'.$question["id"].'">
                            <div class="accordion-body">
                            <div class="col-lg-12">
                            </div>
                                <div class="card bd shadow rounded">
                                    <div class="card-header tx-medium px-3 pt-2  bg-white rounded">
                                        <div class="row">
                                            <div class="col-lg-8">
                                                <h4 class="pt-3">
                                                    '.$response_html.'
                                                </h4>
                                            </div>

                                        </div>
                                    </div>
                                    <div class="card-body bg-light ">
                                        <div class="row pt-1">
                                            <div class="col-sm-9">
                                                <p class="mg-b-0 fw-bold text-muted pt-2"> <a id="'.$question->id.'" title="Add Notes" class="edit-row"  data-bs-toggle="modal" data-bs-target="#NotesModal"> <i
                                                        class="fa fa-edit"></i> </a>
                                                </p>
                                                <p>'.$question->notes.'</p>
                                            </div>
                                            <div class="col-sm-3">
                                                <br>
                                                <span class="text-end" style="float:right; cursor:pointer;" data-bs-toggle="modal"
                                                    data-bs-target="#exampleModal1">
                                                    <a id="'.$question->id.'" class="edit-task" data-bs-toggle="modal"
                                                    data-bs-target="#exampleModal1" style="display:'.($question->logic_trigger==0 ? 'display': 'none').'; margin-left:5%"> <i class="fas fa-check-square mx-2 "></i> Action </a>
                                                </span>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div id="child" style="margin-left:3%">
                                '.($childQuestion ? self::poll_detail_question_HTML($q_key,$childQuestion,true) : '').'
                                </div>
                            </div>
                        </div>
                    </div>';

                return $html;
        }
    }


    public function input_question_responses($id)
    {
        $question = Question::where('id',$id)->with('polling_question_submit')->first();
        $paginate_value = 2;
        $question_responses = PollingQuestion::where('question_id', $question->id)->paginate($paginate_value);
        return view('poll.poll_question_responses',compact('question_responses','question','paginate_value'));
    }

    // Poll Detail and Dwonload PDF
    public function Download_Poll_Questions()
    {
        return view('poll.poll_detail_download');
    }

    public function Genereate_Pdf(Request $request)
    {
        $poll_name=$request->poll_name;
        $data = $request->data;
        $polling_id=$request->polling_id;
        $pollquestions=Question::where('polling_id',$polling_id)->get();
        $hash = mt_rand(999,100000);
        $time = time();
        $filename = ucwords($poll_name).'-'.$hash.'-'.$time.'.pdf';

        $pdf=PDF::loadView('poll.poll_detail_download',["poll_name"=>$poll_name,'questions'=>$pollquestions,'polling_id'=>$polling_id,'data'=>$data])->save(public_path('/toast/').$filename);
        return response()->json(['status'=>'success', 'filename'=>$filename]);
    }

    public function delete_Pdf(Request $request)
    {
        $pdf=$request->file;
        $path = public_path("toast/");

        if (file_exists($path.$pdf))
        {
            @unlink($path.$pdf);
        }

        return response()->json(['status'=>'success']);
    }

    public function Do_list()
    {
        return view('dolist.dolist');
    }


    public function delete_poll($id)
    {
        $polling=PollingList::find($id);
        $poll_qeustion=Question::where('polling_id',$polling->id)->delete();
        $polling->delete();

        return response()->json(['status'=>'success','msg'=>'Deleted Successfully'], 200);
    }

    public function delete_question($id)
    {
        $poll_qeustion=Question::where('id',$id)->delete();
        return response()->json(['status'=>'success','msg'=>'Deleted Successfully'], 200);
    }

    public function getMoreData(Request $request)
    {
        $old_paginate_value = $request->paginate_value;

        $data = PollingQuestion::where('question_id', $request->question_id)->offset($old_paginate_value)->limit(2)->get();

        // dd($request->paginate_value);

        return response()->json([
            'data'=>$data
        ]);
    }


    public function GenereateAll_Pdf(Request $request)
    {
        // dd($request->all());

        $hash = mt_rand(999,100000);
        $time = time();
        $filename = ucwords($request->polling_id).'-'.$hash.'-'.$time.'.pdf';

        $pdf = PDF::loadView('poll.download_all_analytic',[
            'datas'=>$request->all_data,
            'polling_name'=>$request->polling_name,
        ])->save(public_path('/toast/').$filename);

        return response()->json(['status'=>'success', 'filename'=>$filename]);
    }

    public function pollIndex(){

        return view('poll.poll_index');

    }

    public function generatePoll(){
        $login_user = auth()->user();
        $role = getRole();
        if($role->hasPermissionTo('polling list generate poll'))
        {
            return view('poll.generate_poll', compact('login_user'));
        }
        else
        {
            return back();
        }
    }

    public function DraftPoll(){
        $login_user = auth()->user();

        $package = Plan::where('code', $login_user->package_name)->first();

        $features_ids = json_decode($package->sub_feature);
        $polling_1 = Feature::whereIn('id', $features_ids)->where('short_code', 'polling_funel')->first();

        // $pollinglists = PollingList::where('client_id',$login_user->id)->get();
        $pollinglists = PollingList::where('client_id',$login_user->id)->paginate(1);
        $question_count = Question::where('client_id',$login_user->id)->count();

        // dd($pollinglists[0]);

        return view('poll.draft_poll',compact('polling_1','login_user','pollinglists','question_count'));
    }

}
